﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;

namespace MilitaryGuaranteeCard
{
    /// <summary>
    /// Dll导入
    /// </summary>
    public class DllImport
    {
        #region Define

        /// <summary>
        /// 动态库路径
        /// </summary>
        private const String DllPath = @"PLA\RW_VC_MMSC.dll";

        #endregion

        #region DllImport

        [DllImport(DllPath, EntryPoint = "UnloadTargetDll", CallingConvention = CallingConvention.StdCall,
           CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern void UnloadTargetDll();

        [DllImport(DllPath, EntryPoint = "OpenComm", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int OpenComm(string devPort);
        
        [DllImport(DllPath, EntryPoint = "CloseComm", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int CloseComm();
        
        [DllImport(DllPath, EntryPoint = "PowerOn", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int PowerOn(IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "PowerOff", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int PowerOff(IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "ReadCard", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int ReadCard(uint zone, uint addr, uint len, IntPtr recData, ref uint pLen);

        [DllImport(DllPath, EntryPoint = "WriteCard", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int WriteCard (uint zone,uint addr,uint len,byte[] sendData,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "ChkSecret", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int ChkSecret (int keyType,byte[] key,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "WriteSecret", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int WriteSecret (int keyType,byte[] key,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "ReadSecret", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int ReadSecret (int keyType,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "HexStrToByte", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int HexStrToByte (string str,ref byte[] data);
        
        [DllImport(DllPath, EntryPoint = "ByteToHexStr", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int ByteToHexStr (byte[] data,uint size,ref string str);
        
        [DllImport(DllPath, EntryPoint = "HexByteToDec", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int HexByteToDec (byte[] strBytes,ref ulong dec);
        
        [DllImport(DllPath, EntryPoint = "DecToHexByte", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int  DecToHexByte (ulong dec,ref byte[] strBytes) ;
        
        [DllImport(DllPath, EntryPoint = "SetKeyVersion", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int  SetKeyVersion (int keyKind,int keyVer,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "Chk1608Secret", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int Chk1608Secret (int keyNo,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "Authenfic1608", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int Authenfic1608 (IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "HexByteToLong", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int HexByteToLong (byte[] strBytes,ref ulong dec);
        
        [DllImport(DllPath, EntryPoint = "LongToHexByte", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int LongToHexByte (ulong dec,ref byte[] strBytes);
        
        [DllImport(DllPath, EntryPoint = "Signature", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int Signature (byte[] idInfo,byte[] info,int infoLen,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "VerifySignet", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int VerifySignet (byte[] idInfo,byte[] info,int infoLen,byte[] infoSign,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "WriteIDInfo", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int WriteIDInfo (byte[] idInfo,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "PINOpfunc", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int PINOpfunc (int iopType,int slot,byte[] pinInfo,int pinInfoLen,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "UpdateIDInfo", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int UpdateIDInfo (byte[] rightInfo,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "LockUserCard", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int LockUserCard (IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "ReadSamIDInfo", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int ReadSamIDInfo (IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "GetICCardNo", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int GetICCardNo (int slot,IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "PowerOnSam", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int PowerOnSam (IntPtr recData,ref uint pLen);
        
        [DllImport(DllPath, EntryPoint = "HexStrToByte", CallingConvention = CallingConvention.StdCall,
            CharSet = CharSet.Ansi, SetLastError = false)]
        public static extern int GetUpdateIDRight (byte[] icCardNo,byte[] hospitalId,IntPtr recData,ref uint pLen);
        #endregion
    }
}
